<template>
  <div class="component-container">
    <List
      :tableData="items"
      @pass="data => handleVerifed(data, true)"
      @unpass="data => handleVerifed(data, false)"
    ></List>
  </div>
</template>

<script>
import List from "./components/list";
import { accounts } from "@/api";
import dayjs from "dayjs";
import MessagesDialog from "@/mixins/messagesDialog";

export default {
  name: "AllUserRequestTab",
  components: {
    List
  },
  mixins: [MessagesDialog],
  data() {
    return {
      items: []
    };
  },
  async created() {
    await this.fetchAccounts();
  },
  methods: {
    async fetchAccounts() {
      let result = await accounts.list({
        filters: {
          where: {
            isVerified: null
          },
          order: [
            {
              key: "updatedAt",
              sort: "desc"
            }
          ]
        }
      });
      this.items = result.items.map(data => {
        data.createdAt = dayjs(data.createdAt).format("YYYY-MM-DD HH:mm:ss");
        return data;
      });
    },
    async handleVerifed(data, status) {
      data.isVerified = status;
      let { id, isVerified, username, phone } = data;
      try {
        await accounts.update({ id, isVerified, username, phone });
        this.successDialog("审批成功！");
      } catch (err) {
        this.errorDialog(err);
      }
      await this.fetchAccounts();
    }
  }
};
</script>
